--------------------------------------------------------------------------------
-- Copyright (c) 1995-2008 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 10.1
--  \   \         Application : sch2vhdl
--  /   /         Filename : glue.vhf
-- /___/   /\     Timestamp : 09/26/2009 20:55:19
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: /mnt/hdd1/Xilinx10.1/ISE/bin/lin/unwrapped/sch2vhdl -intstyle ise -family xc9500 -flat -suppress -w /home/dcihlar/Hardware/mini386/glue/glue.sch glue.vhf
--Design Name: glue
--Device: xc9500
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity glue is
   port ( A        : in    std_logic_vector (3 downto 1); 
          ADS      : in    std_logic; 
          A23      : in    std_logic; 
          BHEn     : in    std_logic; 
          BLEn     : in    std_logic; 
          CLKIN    : in    std_logic; 
          DC       : in    std_logic; 
          HLDA     : in    std_logic; 
          KEYBINTn : in    std_logic; 
          LOCKn    : in    std_logic; 
          MIO      : in    std_logic; 
          MISO     : in    std_logic; 
          RST      : in    std_logic; 
          RTCINTn  : in    std_logic; 
          TMRINTn  : in    std_logic; 
          WR       : in    std_logic; 
          A1O      : out   std_logic; 
          CLKE     : out   std_logic; 
          CLK2     : out   std_logic; 
          CPU_RST  : out   std_logic; 
          DH       : out   std_logic_vector (7 downto 0); 
          HOLD     : out   std_logic; 
          INTR     : out   std_logic; 
          LEDn     : out   std_logic; 
          MOSI     : out   std_logic; 
          RAMHEn   : out   std_logic; 
          RDn      : out   std_logic; 
          READYn   : out   std_logic; 
          REMLEn   : out   std_logic; 
          ROMA0    : out   std_logic; 
          ROMEn    : out   std_logic; 
          SCK      : out   std_logic; 
          SPICE    : out   std_logic_vector (2 downto 0); 
          WRn      : out   std_logic; 
          DL       : inout std_logic_vector (7 downto 0));
end glue;

architecture BEHAVIORAL of glue is
   attribute BOX_TYPE   : string ;
   signal iint          : std_logic_vector (3 downto 0);
   signal REGE          : std_logic_vector (3 downto 0);
   signal XLXN_7        : std_logic;
   signal XLXN_39       : std_logic;
   signal XLXN_41       : std_logic;
   signal XLXN_46       : std_logic;
   signal CPU_RST_DUMMY : std_logic;
   signal CLK2_DUMMY    : std_logic;
   component selector
      port ( CPUCLK : in    std_logic; 
             Reset  : in    std_logic; 
             A23    : in    std_logic; 
             ADS    : in    std_logic; 
             MIO    : in    std_logic; 
             DC     : in    std_logic; 
             READY  : in    std_logic; 
             BLEn   : in    std_logic; 
             BHEn   : in    std_logic; 
             RDn    : in    std_logic; 
             A      : in    std_logic_vector (3 downto 1); 
             WRn    : out   std_logic; 
             ROME   : out   std_logic; 
             RAMLEn : out   std_logic; 
             RAMHEn : out   std_logic; 
             INTA   : out   std_logic; 
             REGE   : out   std_logic_vector (3 downto 0));
   end component;
   
   component romdemux
      port ( CLK   : in    std_logic; 
             CE    : in    std_logic; 
             RDn   : in    std_logic; 
             DL    : in    std_logic_vector (7 downto 0); 
             READY : out   std_logic; 
             ROMA0 : out   std_logic; 
             ROMEn : out   std_logic; 
             DH    : out   std_logic_vector (7 downto 0));
   end component;
   
   component spisel
      port ( CE : in    std_logic; 
             D  : in    std_logic_vector (2 downto 0); 
             Q  : out   std_logic_vector (2 downto 0));
   end component;
   
   component spi
      port ( CLK  : in    std_logic; 
             RST  : in    std_logic; 
             DREG : in    std_logic; 
             SREG : in    std_logic; 
             WR   : in    std_logic; 
             MISO : in    std_logic; 
             SCK  : out   std_logic; 
             MOSI : out   std_logic; 
             INT  : out   std_logic; 
             D    : inout std_logic_vector (7 downto 0));
   end component;
   
   component intctrl
      port ( Reset : in    std_logic; 
             INTA  : in    std_logic; 
             INT   : in    std_logic_vector (3 downto 0); 
             INTR  : out   std_logic; 
             D     : inout std_logic_vector (7 downto 0));
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component clkdiv2
      port ( CLK2 : in    std_logic; 
             CLK  : out   std_logic);
   end component;
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
begin
   CLK2 <= CLK2_DUMMY;
   CPU_RST <= CPU_RST_DUMMY;
   U1 : selector
      port map (A(3 downto 1)=>A(3 downto 1),
                ADS=>ADS,
                A23=>A23,
                BHEn=>BHEn,
                BLEn=>BLEn,
                CPUCLK=>CLK2_DUMMY,
                DC=>DC,
                MIO=>MIO,
                RDn=>WR,
                READY=>XLXN_41,
                Reset=>CPU_RST_DUMMY,
                INTA=>XLXN_46,
                RAMHEn=>RAMHEn,
                RAMLEn=>REMLEn,
                REGE(3 downto 0)=>REGE(3 downto 0),
                ROME=>XLXN_39,
                WRn=>WRn);
   
   U2 : romdemux
      port map (CE=>XLXN_39,
                CLK=>CLK2_DUMMY,
                DL(7 downto 0)=>DL(7 downto 0),
                RDn=>WR,
                DH(7 downto 0)=>DH(7 downto 0),
                READY=>XLXN_41,
                ROMA0=>ROMA0,
                ROMEn=>ROMEn);
   
   U3 : spisel
      port map (CE=>REGE(0),
                D(2 downto 0)=>DL(2 downto 0),
                Q(2 downto 0)=>SPICE(2 downto 0));
   
   U4 : spi
      port map (CLK=>CLK2_DUMMY,
                DREG=>REGE(1),
                MISO=>MISO,
                RST=>CPU_RST_DUMMY,
                SREG=>REGE(2),
                WR=>WR,
                INT=>iint(3),
                MOSI=>MOSI,
                SCK=>SCK,
                D(7 downto 0)=>DL(7 downto 0));
   
   U5 : intctrl
      port map (INT(3 downto 0)=>iint(3 downto 0),
                INTA=>XLXN_46,
                Reset=>CPU_RST_DUMMY,
                INTR=>INTR,
                D(7 downto 0)=>DL(7 downto 0));
   
   XLXI_1 : BUF
      port map (I=>HLDA,
                O=>open);
   
   XLXI_3 : GND
      port map (G=>HOLD);
   
   XLXI_4 : clkdiv2
      port map (CLK2=>CLKIN,
                CLK=>XLXN_7);
   
   XLXI_5 : clkdiv2
      port map (CLK2=>XLXN_7,
                CLK=>CLK2_DUMMY);
   
   XLXI_11 : VCC
      port map (P=>CLKE);
   
   XLXI_18 : INV
      port map (I=>XLXN_41,
                O=>READYn);
   
   XLXI_23 : BUF
      port map (I=>WR,
                O=>RDn);
   
   XLXI_24 : BUF
      port map (I=>LOCKn,
                O=>open);
   
   XLXI_25 : BUF
      port map (I=>A(1),
                O=>A1O);
   
   XLXI_26 : BUF
      port map (I=>RST,
                O=>CPU_RST_DUMMY);
   
   XLXI_28 : INV
      port map (I=>REGE(3),
                O=>LEDn);
   
   XLXI_31 : BUF
      port map (I=>KEYBINTn,
                O=>iint(0));
   
   XLXI_32 : BUF
      port map (I=>TMRINTn,
                O=>iint(1));
   
   XLXI_34 : BUF
      port map (I=>RTCINTn,
                O=>iint(2));
   
end BEHAVIORAL;


