----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:44:34 10/08/2009 
-- Design Name: 
-- Module Name:    standby - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity standby is
    Port ( Reset : in  STD_LOGIC;
           SET : in  STD_LOGIC;
           CLR : in  STD_LOGIC;
           CLKE : out  STD_LOGIC);
end standby;

architecture Behavioral of standby is

	signal iCLKE : STD_LOGIC := '1';

begin

	process (Reset, SET, CLR)
	begin
		if (Reset = '1') then
			iCLKE <= '0';
		elsif (CLR = '1') then
			iCLKE <= '1';
		elsif (falling_edge(SET)) then
			iCLKE <= '0';
		end if;
	end process;
	
	CLKE <= iCLKE;

end Behavioral;

